#include<iostream>
#include<cmath>
#include<algorithm>
using namespace std;


int main()
{
	int n;
	cin>>n;
	int a[n];
	int b[n];
	n--;
	for(int i=0;i<n;i++)
	{
		cin>>a[i]>>b[i];
	}
	sort(a,a+n);
	sort(b,b+n);
		

	int min=a[0];
	int max=0;
	int max2=0;
	int min2=b[0];
	for(int i=0;i<n;i++)
	{
		if(a[i]>max)
		{
			
			max=a[i];
		}
		
		if(a[i]<min)
		{
			min=a[i];
		}
	}
	
	for(int i=0;i<n;i++)
	{
		if(b[i]>max)
		{
		
			max=b[i];
		}
		
		if(b[i]<min)
		{
			min=b[i];
		}
	}
	if(abs(max-min2)<abs(max2-min))
	cout<<abs(max-min2);
	else
	cout<<abs(max2-min);

	
	return 0;
	
	
	
}